;  program :  Pipe
;  system   : DOS
;  compiler : FASM
;  author    : macgub, palette by loveC
;  email      : macgub3@wp.pl


; requires FPU

ystart equ 70
yend equ 131 
macro draw 
{
  mov ax,[y]
  mov bx,ax
  shl ax,8
  shl bx,6
  add ax,bx
  push ax
  add ax,[x1]
  mov di,ax
  mov al,byte [col]
  mov [gs:di],al
  pop ax
  add ax,[x2]
  mov di,ax
  mov al,byte [col]
  mov [gs:di],al
}
macro draw3d
{       
  fld [sq]
  fimul [z]
  fld st
  fld st
  fiadd [x1]
  fistp [x1]
  fchs
  fiadd [y]
  fistp [y]
  fiadd [x2]
  fistp [x2]
  draw
}
macro setcol
{
  fild [z]
  fmul [pidiv2]
  fidiv [maxz]
  fcos
  fimul [maxz]
  fistp [col]
}
macro setangle
{
  fldpi
  fidiv [i180]
  fimul [anglecounter]
  fsincos
  fstp [sinbeta]
  fstp [cosbeta]
  cmp [anglecounter],360
  jne endseta
  mov [anglecounter],0
endseta:
  inc [anglecounter] 
}  
macro rotate
{
  mov ax,[z]
  sub ax,[zaxle]
  mov [subz],ax
  mov ax,[x1]
  sub ax,[xaxle]
  mov [subx1],ax
  mov ax,[x2]
  sub ax,[xaxle]
  mov [subx2],ax
  fld [sinbeta]
  fimul [subz]
  fchs
  fiadd [xaxle]
  fld st
  fld [cosbeta]
  fimul [subx1]
  faddp
  fistp [x1]
  fld [cosbeta]
  fimul [subx2]
  faddp
  fistp [x2]
  fld [sinbeta]
  fimul [subx1]
  fld [cosbeta]
  fimul [subz]
  faddp
  fiadd [zaxle]
  fistp [z]
}
macro clrscr
{
  mov cx,64000/2
  xor ax,ax
  xor di,di
  cld  
  rep stosw
}
macro copybuf
{
  push ds
  push gs
  pop ds
  xor si,si
  xor di,di
  mov cx,64000/2
  cld
  rep movsw
  pop ds
}
macro clearbuf
{
  push gs
  pop es
  xor di,di
  xor ax,ax
  mov cx,64000/2
  cld
  rep stosw
  push 0a000h
  pop es  
}
	org	100h

	mov	ax,13h
	int	10h
	push	0A000h
	pop	es
	push	cs
	pop	ax
	add	ax,300h
	mov	gs,ax
;one-palette:
;	mov	dx,3C8h
;	xor	al,al
;	out	dx,al
;	inc	dl
;	mov	cx,64
;   vga_palette:
;	out	dx,al
;	out	dx,al
;	out	dx,al
;	inc	al
;	loop	vga_palette

;another_palette:
;	xor	cx,cx
;PALETTE:
;	mov	dx,3C8h
;	mov	al,cl
;	out	dx,al
;	inc	dx
;	out	dx,al
;	mul	al
;	shr	ax,6
;	out	dx,al
;	xor	ax,ax
;	out	dx,al
;	stosb
;	loop	PALETTE

;another_palette:
;------------loveC-----------
	mov	cl,0
PALETE:	mov	ax,cx
	mov	dx,3C8h
	out	dx,al		; color number
	inc	dx
	shr	ax,2
	add	al,4
	out	dx,al		; RED
	sub	al,4
	out	dx,al		; GREEN
	cmp	cl,63
	cmc
	salc
	or	al,cl
	out	dx,al
	loop	PALETE
;-----loveC-----------------

  finit
againObject:
  mov [z],0
  setangle
  clearbuf
 again:
   mov [y],ystart
   elipse:
     fild [yo]
     fchs
     fiadd [y]
     fidiv [a]
     fmul st,st0
     fchs
     fld1
     faddp 
     fsqrt
     fimul[b]
     fld st
     fiadd [xo]
     fistp [x1]
     fchs
     fiadd [xo]
     fistp [x2]
     push [y] 	
     push [z]
     rotate
     setcol
     draw3d ;(x1,x2,y,z)
     pop [z]
     pop [y]
     inc [y]
    cmp [y],yend
    jnz elipse
    inc [z]
  cmp [z],224
  jnz again
  copybuf

	againReadkey:
	in al,60h
	cbw
	dec ax
	jnz againObject
	;jnz againReadkey

	xor	ah,ah
	int	16h
	mov	al,3
	int	10h
	int	20h


  
  sq dd 0.303
  pidiv2 dd 1.5
  i180 dw 180
  y dw 0
  z dw 0
  x1 dw ?
  x2 dw ?
  maxz dw 224
  

  col dw 0 
  xo dd 160
  yo dd 100
  a dd 30
  b dd 30

  sinbeta dd ?
  cosbeta dd ?
  subz  dw ?
  subx1 dw ?
  subx2 dw ?
  anglecounter dw 1
  zaxle dw 112
  xaxle dw 159
  buffer rb 64500